'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.raw = exports.useNow = exports.useComponentId = exports.ComponentMetaContext = exports.usePage = exports.useSession = exports.useAsyncQueryDoc = exports.useBatchQueryDoc = exports.useQueryDoc = exports.useLocalDoc = exports.useAsyncQueryIds = exports.useBatchQueryIds = exports.useQueryIds = exports.useEmit = exports.useOn = exports.useModel = exports.emit = exports.useBatch = exports.useValue = exports.useLocal = exports.useAsyncApi = exports.useBatchApi = exports.useApi = exports.useAsyncQuery = exports.useBatchQuery = exports.useQuery = exports.useAsyncDoc = exports.useBatchDoc = exports.useDoc = exports.destroyer = exports.observer = exports.subApi = exports.subValue = exports.subQuery = exports.subDoc = exports.subLocal = exports.clone = exports.initLocalCollection = exports._semaphore = exports.batchModel = exports.batch = exports.batching = exports.subscribe = exports.$root = exports.model = undefined;

var _model = require('@startupjs/model');

Object.defineProperty(exports, 'model', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_model).default;
  }
});
Object.defineProperty(exports, '$root', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_model).default;
  }
});

var _semaphore = require('./semaphore');

Object.defineProperty(exports, '_semaphore', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_semaphore).default;
  }
});

var _util = require('./util');

Object.defineProperty(exports, 'initLocalCollection', {
  enumerable: true,
  get: function get() {
    return _util.initLocalCollection;
  }
});
Object.defineProperty(exports, 'clone', {
  enumerable: true,
  get: function get() {
    return _util.clone;
  }
});

var _subscriptionTypeFns = require('./subscriptionTypeFns');

Object.defineProperty(exports, 'subLocal', {
  enumerable: true,
  get: function get() {
    return _subscriptionTypeFns.subLocal;
  }
});
Object.defineProperty(exports, 'subDoc', {
  enumerable: true,
  get: function get() {
    return _subscriptionTypeFns.subDoc;
  }
});
Object.defineProperty(exports, 'subQuery', {
  enumerable: true,
  get: function get() {
    return _subscriptionTypeFns.subQuery;
  }
});
Object.defineProperty(exports, 'subValue', {
  enumerable: true,
  get: function get() {
    return _subscriptionTypeFns.subValue;
  }
});
Object.defineProperty(exports, 'subApi', {
  enumerable: true,
  get: function get() {
    return _subscriptionTypeFns.subApi;
  }
});

var _observer = require('./hooks/observer');

Object.defineProperty(exports, 'observer', {
  enumerable: true,
  get: function get() {
    return _observer.observer;
  }
});

var _destroyer = require('./hooks/destroyer');

Object.defineProperty(exports, 'destroyer', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_destroyer).default;
  }
});

var _types = require('./hooks/types');

Object.defineProperty(exports, 'useDoc', {
  enumerable: true,
  get: function get() {
    return _types.useDoc;
  }
});
Object.defineProperty(exports, 'useBatchDoc', {
  enumerable: true,
  get: function get() {
    return _types.useBatchDoc;
  }
});
Object.defineProperty(exports, 'useAsyncDoc', {
  enumerable: true,
  get: function get() {
    return _types.useAsyncDoc;
  }
});
Object.defineProperty(exports, 'useQuery', {
  enumerable: true,
  get: function get() {
    return _types.useQuery;
  }
});
Object.defineProperty(exports, 'useBatchQuery', {
  enumerable: true,
  get: function get() {
    return _types.useBatchQuery;
  }
});
Object.defineProperty(exports, 'useAsyncQuery', {
  enumerable: true,
  get: function get() {
    return _types.useAsyncQuery;
  }
});
Object.defineProperty(exports, 'useApi', {
  enumerable: true,
  get: function get() {
    return _types.useApi;
  }
});
Object.defineProperty(exports, 'useBatchApi', {
  enumerable: true,
  get: function get() {
    return _types.useBatchApi;
  }
});
Object.defineProperty(exports, 'useAsyncApi', {
  enumerable: true,
  get: function get() {
    return _types.useAsyncApi;
  }
});
Object.defineProperty(exports, 'useLocal', {
  enumerable: true,
  get: function get() {
    return _types.useLocal;
  }
});
Object.defineProperty(exports, 'useValue', {
  enumerable: true,
  get: function get() {
    return _types.useValue;
  }
});
Object.defineProperty(exports, 'useBatch', {
  enumerable: true,
  get: function get() {
    return _types.useBatch;
  }
});

var _helpers = require('./hooks/helpers');

Object.defineProperty(exports, 'emit', {
  enumerable: true,
  get: function get() {
    return _helpers.emit;
  }
});
Object.defineProperty(exports, 'useModel', {
  enumerable: true,
  get: function get() {
    return _helpers.useModel;
  }
});
Object.defineProperty(exports, 'useOn', {
  enumerable: true,
  get: function get() {
    return _helpers.useOn;
  }
});
Object.defineProperty(exports, 'useEmit', {
  enumerable: true,
  get: function get() {
    return _helpers.useEmit;
  }
});
Object.defineProperty(exports, 'useQueryIds', {
  enumerable: true,
  get: function get() {
    return _helpers.useQueryIds;
  }
});
Object.defineProperty(exports, 'useBatchQueryIds', {
  enumerable: true,
  get: function get() {
    return _helpers.useBatchQueryIds;
  }
});
Object.defineProperty(exports, 'useAsyncQueryIds', {
  enumerable: true,
  get: function get() {
    return _helpers.useAsyncQueryIds;
  }
});
Object.defineProperty(exports, 'useLocalDoc', {
  enumerable: true,
  get: function get() {
    return _helpers.useLocalDoc;
  }
});
Object.defineProperty(exports, 'useQueryDoc', {
  enumerable: true,
  get: function get() {
    return _helpers.useQueryDoc;
  }
});
Object.defineProperty(exports, 'useBatchQueryDoc', {
  enumerable: true,
  get: function get() {
    return _helpers.useBatchQueryDoc;
  }
});
Object.defineProperty(exports, 'useAsyncQueryDoc', {
  enumerable: true,
  get: function get() {
    return _helpers.useAsyncQueryDoc;
  }
});
Object.defineProperty(exports, 'useSession', {
  enumerable: true,
  get: function get() {
    return _helpers.useSession;
  }
});
Object.defineProperty(exports, 'usePage', {
  enumerable: true,
  get: function get() {
    return _helpers.usePage;
  }
});

var _meta = require('./hooks/meta');

Object.defineProperty(exports, 'ComponentMetaContext', {
  enumerable: true,
  get: function get() {
    return _meta.ComponentMetaContext;
  }
});
Object.defineProperty(exports, 'useComponentId', {
  enumerable: true,
  get: function get() {
    return _meta.useComponentId;
  }
});
Object.defineProperty(exports, 'useNow', {
  enumerable: true,
  get: function get() {
    return _meta.useNow;
  }
});

var _observerUtil = require('@nx-js/observer-util');

Object.defineProperty(exports, 'raw', {
  enumerable: true,
  get: function get() {
    return _observerUtil.raw;
  }
});

var _globalInit = require('./globalInit');

var _globalInit2 = _interopRequireDefault(_globalInit);

var _patchRacer = require('./patchRacer');

var _patchRacer2 = _interopRequireDefault(_patchRacer);

var _subscribe = require('./subscribe');

var _subscribe2 = _interopRequireDefault(_subscribe);

var _batching = require('./batching');

var _batching2 = _interopRequireDefault(_batching);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.subscribe = _subscribe2.default;
exports.batching = _batching2.default;
exports.batch = _batching.batch;
exports.batchModel = _batching.batchModel;


(0, _globalInit2.default)();
(0, _patchRacer2.default)();